/**
 * CompareRequest.java
 *
 * File generated from the core::CompareRequest uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.hpd;

// End of user code
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;

import org.w3c.dom.Document;
import org.w3c.dom.Node;


/**
 * Description of the class CompareRequest.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "CompareRequest", propOrder = {
	"assertion",
	"dn"
})
@XmlRootElement(name = "CompareRequest")
public class CompareRequest extends net.ihe.gazelle.hpd.DsmlMessage implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElement(name = "assertion", required = true, namespace = "urn:oasis:names:tc:DSML:2:0:core")
	public net.ihe.gazelle.hpd.AttributeValueAssertion assertion;
	@XmlAttribute(name = "dn", required = true)
	public java.lang.String dn;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return assertion.
	 * @return assertion
	 */
	public net.ihe.gazelle.hpd.AttributeValueAssertion getAssertion() {
	    return assertion;
	}
	
	/**
	 * Set a value to attribute assertion.
	 * @param assertion.
	 */
	public void setAssertion(net.ihe.gazelle.hpd.AttributeValueAssertion assertion) {
	    this.assertion = assertion;
	}
	
	
	
	
	/**
	 * Return dn.
	 * @return dn
	 */
	public java.lang.String getDn() {
	    return dn;
	}
	
	/**
	 * Set a value to attribute dn.
	 * @param dn.
	 */
	public void setDn(java.lang.String dn) {
	    this.dn = dn;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.hpd");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:oasis:names:tc:DSML:2:0:core", "CompareRequest").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(CompareRequest compareRequest, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (compareRequest != null){
   			net.ihe.gazelle.hpd.DsmlMessage.validateByModule(compareRequest, _location, cvm, diagnostic);
			net.ihe.gazelle.hpd.AttributeValueAssertion.validateByModule(compareRequest.getAssertion(), _location + "/assertion", cvm, diagnostic);
    	}
    }

}